"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const require_strict_mode_1 = __importDefault(require("./require-strict-mode"));
const ts_eslint_1 = require("@typescript-eslint/experimental-utils/dist/ts-eslint");
const ruleTesterForTSConfig = (config) => new ts_eslint_1.RuleTester({
    parserOptions: {
        sourceType: "module",
        project: config,
        // EXPERIMENTAL_useSourceOfProjectReferenceRedirect: true,
    },
    parser: require.resolve("@typescript-eslint/parser"),
});
const strictRuleTester = ruleTesterForTSConfig("./tsconfig.tests.json");
// eslint-disable-next-line functional/no-expression-statement, sonarjs/no-duplicate-string
strictRuleTester.run("require-strict-mode", require_strict_mode_1.default, {
    valid: [
        {
            filename: "file.ts",
            code: "// strictRuleTester",
        },
    ],
    invalid: [],
});
// TODO re-enable
// const nonStrictRuleTester = ruleTesterForTSConfig(
//   "./tsconfig.tests.non-strict.json"
// );
// // eslint-disable-next-line functional/no-expression-statement
// nonStrictRuleTester.run("require-strict-mode", rule, {
//   valid: [],
//   invalid: [
//     {
//       filename: "file.ts",
//       code: "// nonStrictRuleTester",
//       errors: [
//         {
//           messageId: "strict",
//           type: AST_NODE_TYPES.Program,
//         },
//       ],
//     },
//   ],
// } as const);
// const nonNoUncheckedIndexedAccessRuleTester = ruleTesterForTSConfig(
//   "./tsconfig.tests.non-noUncheckedIndexedAccess.json"
// );
// // eslint-disable-next-line functional/no-expression-statement
// nonNoUncheckedIndexedAccessRuleTester.run("require-strict-mode", rule, {
//   valid: [],
//   invalid: [
//     {
//       filename: "file.ts",
//       code: "// nonNoUncheckedIndexedAccessRuleTester",
//       errors: [
//         {
//           messageId: "noUncheckedIndexedAccess",
//           type: AST_NODE_TYPES.Program,
//         },
//       ],
//     },
//   ],
// } as const);
// const strictFunctionTypesRuleTester = ruleTesterForTSConfig(
//   "./tsconfig.tests.non-strictFunctionTypes.json"
// );
// // eslint-disable-next-line functional/no-expression-statement
// strictFunctionTypesRuleTester.run("require-strict-mode", rule, {
//   valid: [],
//   invalid: [
//     {
//       filename: "file.ts",
//       code: "// strictFunctionTypesRuleTester",
//       errors: [
//         {
//           messageId: "strictFunctionTypes",
//           type: AST_NODE_TYPES.Program,
//         },
//       ],
//     },
//   ],
// } as const);
